diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 0bb681523..397d2cc2a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -1,77 +1,46 @@
 package net.minecraft.client.render.shader;
 
-import static org.lwjgl.opengl.ARBFramebufferObject.*;
-import static org.lwjgl.opengl.ARBMultitexture.*;
-import static org.lwjgl.opengl.GL20.*;
-
 import java.io.File;
-import java.nio.ByteBuffer;
-import java.nio.FloatBuffer;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import net.minecraft.client.render.tessellator.ShaderParticleTessellator;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.core.block.material.Materials;
-import org.jetbrains.annotations.NotNull;
-import org.joml.Matrix4f;
-import org.lwjgl.opengl.GL30;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Framebuffer;
+import net.minecraft.client.render.FrameBuffer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.camera.CameraUtil;
-import org.lwjgl.system.MemoryUtil;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class ShadersRenderer implements Renderer {
     private static final Logger LOGGER = LogUtils.getLogger();
     public Minecraft mc;
 
-    protected final int vao;
-    protected final Framebuffer worldFramebuffer = new Framebuffer();
-    protected final Texture worldFramebufferTex = new Texture();
+    protected final FrameBuffer worldFramebuffer = new FrameBuffer();
+    protected final Texture worldFramebufferColor = new Texture();
     protected final Texture worldFramebufferDepth = new Texture();
+    protected int worldRenderBufferObject = 0;
 
-    protected final Framebuffer gameFramebuffer = new Framebuffer();
-    protected final Texture gameFramebufferTex = new Texture();
-    protected final Texture gameFramebufferDepth = new Texture();
+    protected final FrameBuffer gameFramebuffer = new FrameBuffer();
+    protected final Texture gameFramebufferColor = new Texture();
+    protected int gameRenderBufferObject = 0;
 
     protected final Shader postShader = new Shader();
     protected final Shader finalShader = new Shader();
-    protected final Shader cloudsShader = new Shader();
-    protected final ShaderGeometry particleShader = new ShaderGeometry();
-
     protected ShaderProvider internal = new ShaderProviderInternal("/shaders/");
 
-    public ShaderParticleTessellator shaderParticleTessellator = new ShaderParticleTessellator(200000);
-
     public int fbWidth;
     public int fbHeight;
 
     public int renderWidth;
     public int renderHeight;
 
-    protected FloatBuffer matrixBuffer = MemoryUtil.memAllocFloat(16);
-    protected Matrix4f matrix = new Matrix4f();
-
     public ShadersRenderer(Minecraft minecraft) {
         this.mc = minecraft;
-
-        if (!Shaders.enableShaders) throw new RuntimeException("Shaders disabled!");
-        if (OpenGLHelper.gl32) {
-            this.vao = GL30.glGenVertexArrays();
-            this.particleShader.supported = true;
-            LOGGER.info("GL32 supported, enabling particle geometry shaders");
-        } else {
-            this.vao = 0;
-            this.particleShader.supported = false;
-            LOGGER.info("GL32 not supported, disabling particle geometry shaders");
-        }
     }
 
     @Override
@@ -83,11 +52,11 @@ public class ShadersRenderer implements Renderer {
         if (this.finalShader.isEnabled()) {
             this.gameFramebuffer.bind();
         } else {
-            glBindFramebuffer(GL_FRAMEBUFFER, 0);
+            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
         }
 
-        glUseProgram(0);
-        glViewport(0, 0, this.fbWidth, this.fbHeight);
+        GL41.glUseProgram(0);
+        GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
 
         OpenGLHelper.checkError("begin render game");
     }
@@ -96,19 +65,19 @@ public class ShadersRenderer implements Renderer {
     public void endRenderGame(float partialTicks) {
         OpenGLHelper.checkError("pre end render game");
 
-        glViewport(0, 0, this.fbWidth, this.fbHeight);
-        glBindFramebuffer(GL_FRAMEBUFFER, 0);
+        GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
 
         if (this.finalShader.isEnabled()) {
             this.finalShader.bind();
 
-            glActiveTextureARB(GL_TEXTURE0_ARB);
-            this.gameFramebufferTex.bind();
+            GL41.glActiveTexture(GL41.GL_TEXTURE0);
+            this.gameFramebufferColor.bind();
             this.finalShader.uniformInt("colortex0", 0);
 
-            Shaders.setUniforms(this.mc, this.finalShader, partialTicks);
-            Shaders.drawFullscreenRect();
-            glUseProgram(0);
+            ShaderHelper.setUniforms(this.mc, this.finalShader, partialTicks);
+            ShaderHelper.drawFullscreenRect();
+            GL41.glUseProgram(0);
         }
 
         OpenGLHelper.checkError("end render game");
@@ -120,40 +89,62 @@ public class ShadersRenderer implements Renderer {
 
         setupFramebuffer();
         this.worldFramebuffer.bind();
-        glViewport(0, 0, this.renderWidth, this.renderHeight);
+        GL41.glViewport(0, 0, this.renderWidth, this.renderHeight);
 
-        glUseProgram(0);
+        GL41.glUseProgram(0);
 
         OpenGLHelper.checkError("begin render world");
     }
 
     @Override
-    public void beginRenderClouds(float partialTicks) {
-        if (this.mc.gameSettings.clouds.value && this.mc.gameSettings.fancyGraphics.value == 1 && this.cloudsShader.isEnabled()) {
-            OpenGLHelper.checkError("pre setup clouds");
+    public void endRenderWorld(float partialTicks) {
+        OpenGLHelper.checkError("pre end render world");
 
-            // Alpha test is implemented in the shader because regular alpha test removes some pixels at the edge
-            glDisable(GL_ALPHA_TEST);
+        if (this.finalShader.isEnabled()) {
+            this.gameFramebuffer.bind();
+        } else {
+            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+        }
 
-            this.cloudsShader.bind();
+        if (this.postShader.isEnabled()) {
+            this.postShader.bind();
 
-            // Read projection matrix, invert it, and send it to the shader
-            this.matrixBuffer.clear();
-            glGetFloatv(GL_PROJECTION_MATRIX, this.matrixBuffer);
+            GL41.glActiveTexture(GL41.GL_TEXTURE0);
+            this.worldFramebufferColor.bind();
+            this.postShader.uniformInt("colortex0", 0);
+            GL41.glActiveTexture(GL41.GL_TEXTURE1);
+            this.worldFramebufferDepth.bind();
+            this.postShader.uniformInt("depthtex0", 1);
+            GL41.glActiveTexture(GL41.GL_TEXTURE0);
 
-            this.matrixBuffer.position(0);
-            this.matrix.set(this.matrixBuffer);
+            this.mc.ppm.enabled = true;
+            ShaderHelper.setUniforms(this.mc, this.postShader, partialTicks);
+            this.mc.ppm.enabled = false;
+        } else {
+            GL41.glUseProgram(0);
+            this.worldFramebufferColor.bind();
+        }
 
-            this.matrix.invert();
+        GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
+        ShaderHelper.drawFullscreenRect();
 
+        LightmapHelper.instance.enableLightmapRendering();
 
-            this.matrixBuffer.clear();
-            this.matrix.get(this.matrixBuffer);
+        GL41.glUseProgram(0);
+//        GL41.glEnable(GL41.GL_ALPHA_TEST);
+
+        OpenGLHelper.checkError("end render world");
+    }
 
-            this.matrixBuffer.position(0);
-            this.matrixBuffer.limit(16);
-            glUniformMatrix4fv(this.cloudsShader.getUniform("gbufferProjectionInverse"), false, this.matrixBuffer);
+    @Override
+    public void beginRenderClouds(float partialTicks) {
+        if (this.mc.gameSettings.clouds.value && this.mc.gameSettings.fancyGraphics.value == 1 && Shaders.CLOUDS.isEnabled()) {
+            OpenGLHelper.checkError("pre setup clouds");
+
+            // Alpha test is implemented in the shader because regular alpha test removes some pixels at the edge
+//            glDisable(GL_ALPHA_TEST);
 
+            Shaders.CLOUDS.bind();
             int isEyeInLiquid;
             if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.LAVA, partialTicks)) {
                 isEyeInLiquid = 2;
@@ -162,108 +153,25 @@ public class ShadersRenderer implements Renderer {
             } else {
                 isEyeInLiquid = 0;
             }
-            glUniform1i(this.cloudsShader.getUniform("isEyeInLiquid"), isEyeInLiquid);
-
-            glUniform1f(this.cloudsShader.getUniform("viewWidth"), this.renderWidth);
-            glUniform1f(this.cloudsShader.getUniform("viewHeight"), this.renderHeight);
+            GL41.glUniform1i(Shaders.CLOUDS.getUniform("isEyeInLiquid"), isEyeInLiquid);
+            GL41.glUseProgram(0);
 
             OpenGLHelper.checkError("setup clouds");
         }
     }
 
     @Override
-    public void beginRenderParticles(float partialTick) {
-        if (this.particleShader.isEnabled()) {
-            OpenGLHelper.checkError("pre enable render particles");
-            GL30.glBindVertexArray(this.vao);
-            this.particleShader.bind();
-
-            this.matrix.identity();
-            glUniformMatrix4fv(this.particleShader.getUniform("model"), false, this.matrix.get(this.matrixBuffer));
-
-            this.mc.worldRenderer.getViewMatrix(this.matrix, partialTick);
-            glUniformMatrix4fv(this.particleShader.getUniform("view"), false, this.matrix.get(this.matrixBuffer));
-
-            if (this.mc.currentScreen instanceof ScreenPhotoMode) {
-                this.matrix.identity();
-            } else {
-                this.mc.worldRenderer.orientCamera(this.matrix.identity(), partialTick).invert();
-            }
-            glUniformMatrix4fv(this.particleShader.getUniform("viewInv"), false, this.matrix.get(this.matrixBuffer));
-
-            this.mc.worldRenderer.getProjectionMatrix(this.matrix, partialTick);
-            glUniformMatrix4fv(this.particleShader.getUniform("projection"), false, this.matrix.get(this.matrixBuffer));
-
-            glUniform1i(this.particleShader.getUniform("texture0"), 0);
-            glUniform1i(this.particleShader.getUniform("texture1"), 1);
-
-            glActiveTexture(GL_TEXTURE1);
-            if (LightmapHelper.isLightmapEnabled()) {
-                glBindTexture(GL_TEXTURE_2D, LightmapHelper.instance.lightmapTexture);
-            } else {
-                this.mc.textureManager.loadTexture("/assets/minecraft/textures/environment/lightmap/disabled.png");
-            }
-            glActiveTexture(GL_TEXTURE0);
+    public void endRenderClouds(float partialTicks) {
 
-            OpenGLHelper.checkError("post enable render particles");
-        }
     }
 
     @Override
-    public @NotNull ParticleTessellator getParticleTessellator() {
-        return this.particleShader.isEnabled() ? this.shaderParticleTessellator : Tessellator.instance;
-    }
-
-    @Override
-    public void endRenderParticles(float partialTicks) {
-        if (this.particleShader.isEnabled()) {
-            glUseProgram(0);
-            GL30.glBindVertexArray(0);
-        }
-    }
+    public void beginRenderParticles(float partialTick) {
 
-    @Override
-    public void endRenderClouds(float partialTicks) {
-        glUseProgram(0);
-        glEnable(GL_ALPHA_TEST);
     }
 
     @Override
-    public void endRenderWorld(float partialTicks) {
-        OpenGLHelper.checkError("pre end render world");
-
-        if (this.finalShader.isEnabled()) {
-            this.gameFramebuffer.bind();
-        } else {
-            glBindFramebuffer(GL_FRAMEBUFFER, 0);
-        }
-
-        if (this.postShader.isEnabled()) {
-            this.postShader.bind();
-
-            glActiveTextureARB(GL_TEXTURE0_ARB);
-            this.worldFramebufferTex.bind();
-            this.postShader.uniformInt("colortex0", 0);
-            glActiveTextureARB(GL_TEXTURE1_ARB);
-            this.worldFramebufferDepth.bind();
-            this.postShader.uniformInt("depthtex0", 1);
-            glActiveTextureARB(GL_TEXTURE0_ARB);
-
-            this.mc.ppm.enabled = true;
-            Shaders.setUniforms(this.mc, this.postShader, partialTicks);
-            this.mc.ppm.enabled = false;
-        } else {
-            glUseProgram(0);
-            this.worldFramebufferTex.bind();
-        }
-
-        glViewport(0, 0, this.fbWidth, this.fbHeight);
-        Shaders.drawFullscreenRect();
-
-        glUseProgram(0);
-        glEnable(GL_ALPHA_TEST);
-
-        OpenGLHelper.checkError("end render world");
+    public void endRenderParticles(float partialTicks) {
     }
 
     public void setupFramebuffer() {
@@ -274,11 +182,12 @@ public class ShadersRenderer implements Renderer {
 
         if (this.fbWidth != this.mc.gameWindow.getWidthPixels() || this.fbHeight != this.mc.gameWindow.getHeightPixels() || this.renderWidth != scaledWidth || this.renderHeight != scaledHeight || !this.gameFramebuffer.isGenerated() || !this.worldFramebuffer.isGenerated()) {
             this.worldFramebuffer.generate();
-            this.worldFramebufferTex.generate();
+            this.worldFramebufferColor.generate();
             this.worldFramebufferDepth.generate();
+            this.worldRenderBufferObject = GL41.glGenRenderbuffers();
             this.gameFramebuffer.generate();
-            this.gameFramebufferTex.generate();
-            this.gameFramebufferDepth.generate();
+            this.gameFramebufferColor.generate();
+            this.gameRenderBufferObject = GL41.glGenRenderbuffers();
 
             this.fbWidth = this.mc.gameWindow.getWidthPixels();
             this.fbHeight = this.mc.gameWindow.getHeightPixels();
@@ -287,72 +196,65 @@ public class ShadersRenderer implements Renderer {
             this.renderHeight = scaledHeight;
 
             boolean filtering = this.mc.gameSettings.renderScale.value.useLinearFiltering;
-            int filterMode = filtering ? GL_LINEAR : GL_NEAREST;
+            int filterMode = filtering ? GL41.GL_LINEAR : GL41.GL_NEAREST;
 
             LOGGER.info("Display: {} x {}, Render: {} x {}", this.fbWidth, this.fbHeight, this.renderWidth, this.renderHeight);
 
             this.worldFramebuffer.bind();
-
-            this.worldFramebufferTex.bind();
-            glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, this.renderWidth, this.renderHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, (ByteBuffer) null);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, filterMode);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, filterMode);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-            glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, this.worldFramebufferTex.id(), 0);
+            this.worldFramebufferColor.bind();
+            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, this.renderWidth, this.renderHeight, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_COLOR_ATTACHMENT0, GL41.GL_TEXTURE_2D, this.worldFramebufferColor.id(), 0);
 
             this.worldFramebufferDepth.bind();
-            glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, this.renderWidth, this.renderHeight, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, (ByteBuffer) null);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, filterMode);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, filterMode);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-            glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, this.worldFramebufferDepth.id(), 0);
+            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_DEPTH_COMPONENT, this.renderWidth, this.renderHeight, 0, GL41.GL_DEPTH_COMPONENT, GL41.GL_FLOAT, 0);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
 
-            this.gameFramebuffer.bind();
+            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_ATTACHMENT, GL41.GL_TEXTURE_2D, this.worldFramebufferDepth.id(), 0);
+
+//            GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, this.worldRenderBufferObject);
+//            GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, GL41.GL_DEPTH24_STENCIL8, this.renderWidth, this.renderHeight);
+//            GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_STENCIL_ATTACHMENT, GL41.GL_RENDERBUFFER, this.worldRenderBufferObject);
 
-            this.gameFramebufferTex.bind();
-            glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, this.fbWidth, this.fbHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, (ByteBuffer) null);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-            glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, this.gameFramebufferTex.id(), 0);
-
-            this.gameFramebufferDepth.bind();
-            glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, this.fbWidth, this.fbHeight, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, (ByteBuffer) null);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-            glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, this.gameFramebufferDepth.id(), 0);
-
-            glBindFramebuffer(GL_FRAMEBUFFER, 0);
+            this.gameFramebuffer.bind();
+            this.gameFramebufferColor.bind();
+            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, this.fbWidth, this.fbHeight, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_COLOR_ATTACHMENT0, GL41.GL_TEXTURE_2D, this.gameFramebufferColor.id(), 0);
+
+            GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, this.gameRenderBufferObject);
+            GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, GL41.GL_DEPTH24_STENCIL8, this.fbWidth, this.fbHeight);
+            GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_STENCIL_ATTACHMENT, GL41.GL_RENDERBUFFER, this.gameRenderBufferObject);
+
+            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
         }
     }
 
     public void reload() {
         LOGGER.info("Reloading Shaders...");
 
-        glUseProgram(0);
-        glBindFramebuffer(GL_FRAMEBUFFER, 0);
+        GL41.glUseProgram(0);
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
 
         OpenGLHelper.checkError("pre shader reload");
 
-        this.matrixBuffer = MemoryUtil.memAllocFloat(16);
-
         this.postShader.delete();
         this.finalShader.delete();
-        this.cloudsShader.delete();
-        this.particleShader.delete();
 
         ShaderProvider shaderProvider = getShader();
 
         if (shaderProvider != null) {
-            this.finalShader.compile(shaderProvider, "base");
-            this.postShader.compile(shaderProvider, "post");
-            this.cloudsShader.compile(shaderProvider, "clouds");
-            this.particleShader.compile(shaderProvider, "particle");
+            this.finalShader.compile(shaderProvider, "post/base");
+            this.postShader.compile(shaderProvider, "post/post");
         }
 
         OpenGLHelper.checkError("shader reload");
@@ -361,14 +263,13 @@ public class ShadersRenderer implements Renderer {
     @Override
     public void delete() {
         this.gameFramebuffer.delete();
-        this.gameFramebufferDepth.delete();
-        this.gameFramebufferTex.delete();
+        GL41.glDeleteRenderbuffers(this.gameRenderBufferObject);
+        this.gameFramebufferColor.delete();
 
         this.worldFramebuffer.delete();
+        GL41.glDeleteRenderbuffers(this.worldRenderBufferObject);
+        this.worldFramebufferColor.delete();
         this.worldFramebufferDepth.delete();
-        this.worldFramebufferTex.delete();
-
-        MemoryUtil.memFree(this.matrixBuffer);
     }
 
     @Override
@@ -385,8 +286,8 @@ public class ShadersRenderer implements Renderer {
         }
     }
 
-    public Texture getWorldFramebufferTex() {
-        return this.worldFramebufferTex;
+    public Texture getWorldFramebufferColor() {
+        return this.worldFramebufferColor;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 1741688fe..492e99b17 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -3,19 +3,17 @@ package net.minecraft.client.render.terrain;
 import java.util.ArrayList;
 import java.util.List;
 
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
-import org.joml.primitives.AABBf;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
-import net.minecraft.client.render.entity.EntityRendererItem;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -25,7 +23,6 @@ public abstract class ChunkRenderer {
     public static int updates = 0;
 
     public World world;
-    protected final int lists;
     public int posX;
     public int posY;
     public int posZ;
@@ -45,27 +42,22 @@ public abstract class ChunkRenderer {
     public int zm;
     public float radius;
     public boolean dirty;
-    public AABBf bb;
+    public AABBd bb;
     public int id;
-    public boolean occlusionVisible;
-    public boolean occlusionQuerying;
-    public int occlusionId;
     public boolean skyLit;
     protected boolean compiled;
     public @NotNull List<@NotNull TileEntity> renderableBlockEntities;
     protected final @NotNull List<@NotNull TileEntity> globalRenderableBlockEntities;
 
-    public ChunkRenderer(@NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+    public ChunkRenderer(@NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
         this.visible = false;
         this.empty = new boolean[MAX_RENDER_PASSES];
-        this.occlusionVisible = true;
         this.compiled = false;
         this.renderableBlockEntities = new ArrayList<>();
         this.world = world;
         this.globalRenderableBlockEntities = globalRenderableTileEntities;
         this.sizeX = this.sizeY = this.sizeZ = size;
         this.radius = MathHelper.sqrt_float(this.sizeX * this.sizeX + this.sizeY * this.sizeY + this.sizeZ * this.sizeZ) / 2.0F;
-        this.lists = lists;
         this.posX = -999;
         setPos(x, y, z);
         this.dirty = false;
@@ -87,18 +79,18 @@ public abstract class ChunkRenderer {
             this.yRender = y - this.yRenderOffs;
             this.zRender = z - this.zRenderOffs;
             float f = 6F;
-            this.bb = new AABBf(x - f, y - f,  z - f, (x + this.sizeX) + f, (y + this.sizeY) + f, (z + this.sizeZ) + f);
-            GL11.glNewList(this.lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
-            EntityRendererItem.renderFlatAABB(new AABBd( this.xRenderOffs - f, this.yRenderOffs - f, this.zRenderOffs - f, (this.xRenderOffs + this.sizeX) + f, (this.yRenderOffs + this.sizeY) + f, (this.zRenderOffs + this.sizeZ) + f));
-            GL11.glEndList();
+            this.bb = new AABBd(x - f, y - f,  z - f, (x + this.sizeX) + f, (y + this.sizeY) + f, (z + this.sizeZ) + f);
             setDirty();
         }
     }
 
     public abstract boolean rebuild(boolean priority);
 
-    public boolean renderBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
+    public boolean renderBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
         boolean rendered = false;
+        tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+        tessellator.setColor4i(255, 255, 255, 255);
+        tessellator.setTextureUV(0.0, 0.0);
         rendered |= model.render(tessellator, worldSource, tilePos);
         if (model.hasOverbright()) {
             rendered |= model.renderOverbright(tessellator, worldSource, tilePos);
@@ -106,10 +98,6 @@ public abstract class ChunkRenderer {
         return rendered;
     }
 
-    protected void translateToPos() {
-        GL11.glTranslatef(this.xRenderOffs, this.yRenderOffs, this.zRenderOffs);
-    }
-
     public float distanceToEntitySquared(Entity entity) {
         float dx = (float) (entity.x - (double) this.xm);
         float dy = (float) (entity.y - (double) this.ym);
@@ -138,23 +126,8 @@ public abstract class ChunkRenderer {
         this.world = null;
     }
 
-    public int getList(int layer) {
-        if (!this.visible) {
-            return -1;
-        }
-        if (!this.empty[layer]) {
-            return this.lists + layer;
-        } else {
-            return -1;
-        }
-    }
-
     public void cull(CameraFrustum frustum, float partialTick) {
-        this.visible = true/*frustum.isVisible(bb, partialTick)*/;
-    }
-
-    public void renderBB() {
-        GL11.glCallList(this.lists + MAX_RENDER_PASSES);
+        this.visible = frustum.isVisible(this.bb, partialTick);
     }
 
     public boolean isEmpty() {
